// All database related API calls

import { BackendQueryFormat } from '../../querybuilder';
import { Broker } from './broker';
import { QueryBuilderText } from '../store/querybuilderSlice';
import { GraphQueryResultFromBackendPayload } from '../store/graphQueryResultSlice';
import { ML, MLTypes } from '../store/mlSlice';

export function wsQueryRequest(ml: ML) {
  const mlEnabled = Object.entries(ml)
    .filter(([_,value]) => value.enabled)
    .map(([key,_]) => {
      return {
        type: key as MLTypes,
        //parameters: []
      }
    })
  Broker.instance().sendMessage({
    key: 'query',
    subKey: 'get',
    body: { 
      queryID: "0", // TODO: not used yet, but used when multiple queries per save state are supported
      ml: mlEnabled,
      cached: false
     }, 
  });
}

export function wsManualQueryRequest(query: string) {
  Broker.instance().sendMessage({
    key: 'query',
    subKey: 'manual',
    body: JSON.stringify({ query }),
  });
}

type QueryTranslationResponse = (data: QueryBuilderText) => void;
export function wsQueryTranslationSubscription(callback: QueryTranslationResponse) {
  const id = Broker.instance().subscribe(callback, 'queryTranslation_result');
  return () => {
    Broker.instance().unSubscribe('queryTranslation_result', id);
  };
}

type QueryResultResponse = (data: GraphQueryResultFromBackendPayload) => void;
export function wsQuerySubscription(callback: QueryResultResponse) {
  const id = Broker.instance().subscribe(callback, 'query_result');
  return () => {
    Broker.instance().unSubscribe('query_result', id);
  };
}
